<?php
/**
 * FireStats integration plugin for Joomla
 * 
 * Author: OneMarko(onemarko@gmail.com)
 */
// No direct access
defined('_JEXEC') or die('Restricted access');

// Import library
jimport('joomla.plugin.plugin');

class  plgSystemFirestats_Joomla extends JPlugin {
	function onAfterInitialise() {
		$fs_folder	= $this->params->get("firestats_path");
		$fs_folder	= plgSystemFirestats_Joomla::path($fs_folder);
		
		$fs_page_id	= intVal($this->params->get("firestats_site_id"));
		$fs_show_error = $this->params->get("firestats_show_error") ? true : false;
		
		if (file_exists($fs_folder."/php/db-hit.php")) {
			include_once($fs_folder."/php/db-hit.php");
			include_once($fs_folder."/php/db-sql.php");
			
			if (fs_site_exists($fs_page_id)) {			
				fs_add_site_hit($fs_page_hist);
			}
			elseif ($fs_show_error) {
				JError::raiseWarning(0, "Site with id '$fs_page_id' was not found in FireStats<br>Please check configuration");
			}
		}
		elseif ($fs_show_error) {
			JError::raiseWarning(1, "Can't locate FireStats in <b>'$fs_folder'</b>.<br>Please check configuration!");
		}
	}
	
	function path($path) {
		$search = array(
		"%joomla_root%",
		"%server_root%"
		);
		$replace = array(
			JPATH_ROOT."/",
			$_SERVER["DOCUMENT_ROOT"]."/"
		);
		
		return str_replace($search, $replace, $path);
	}
}

 


// Edit this line to match your FireStats directory.
// $_SERVER["DOCUMENT_ROOT"] represents the document root on Apache.
//define('FS_PATH',$_SERVER["DOCUMENT_ROOT"].'/new/firestats');

// This is the site ID of your Joomla site inside FireStats sites table.
// You need to add a Joomla site in the Sites tab in FireStats and then change the
// value here to match the ID.
// this will allow FireStats to show the statistics of your Joomla site seperated from your other sites.
//
// Note: This is optional, the default value will also work.
//define('FS_SITE_ID',1);


// no direct access
/*
if (!defined('_JEXEC'))
{
	echo 'FireStats: Restricted access';
	return;
}
$mainframe->registerEvent('onAfterInitialise', 'firestats_joomla_add_hit');

if (!file_exists(FS_PATH.'/php/db-hit.php'))
{
	echo 'FireStats: Error! Check firestats path!';
	return;
}

require_once(FS_PATH.'/php/db-hit.php');

function firestats_joomla_add_hit()
{
	if (function_exists('fs_add_site_hit'))
	{
		fs_add_site_hit(FS_SITE_ID);
		return true;
	}
	else
	{
		return false;
	}
}
*/
?>
