package net.firefang.ip2c;

import java.io.IOException;

public class Benchmark
{
	public static void main(String[] args) throws IOException
	{
		test(false);
		test(true);
	}
	
	private static void test(boolean cache) throws IOException
	{
		if (cache) System.err.println("Testing with memory cache");
		else System.err.println("Testing without memory cache");
		IP2Country ip2c = new IP2Country(cache);
		String ips[] = new String[100000];
		// randomize 100,000 ip addresses.
		for (int i = 0; i < ips.length; i++)
		{
			ips[i] = randomizeIP();
		}
		
		long now = System.currentTimeMillis();
		for (int i = 0; i < ips.length; i++)
		{
			if (i % 5000 == 0) System.err.println((i / 1000) + "% done");
			ip2c.getCountry(ips[i]);
		}
		long t = System.currentTimeMillis() - now;
		float sec = t / 1000f;
		
		System.err.println("Took " + t + " for 100,000 searches ("+100000f / sec+" searches/sec)");

	}

	private static String randomizeIP()
	{
		short b1 = (short) (Math.random() * 256);
		short b2 = (short) (Math.random() * 256);
		short b3 = (short) (Math.random() * 256);
		short b4 = (short) (Math.random() * 256);
		return b1 + "." + b2 + "." + b3 + "." + b4;
	}
}
